; Pll kontrol programi

include "16c84.h"
include "custom.h"
;		   			     AKGUL SOFTWARE          
;****************************     17-04-2001     ANKARA - TURKIYE      AKSOFT ******
LIST P=16c84, F=INHX8M

#define EnPll   PORT_B,4
#define EnLcd   PORT_B,5
#define RsLcd   PORT_B,6

#define CkPll   PORT_B,7

#define DtPll   PORT_A,3
#define RxTx    PORT_A,4

#define KeyDF   Flag,1
#define KeySF   Flag,2
#define KeyFl   Flag,3
#define Dublx   Flag,4
#define RTxPl	Flag,5
#define Ramky	Flag,6

PllTus          equ     0x09
IFHI		equ	0x53
IFLO		equ	0x98
SFTHI		equ	0x02
SFTLO		equ	0x58
TxInitHI	equ	0xb2
TxInitLO	equ	0x20
ChnlFq		equ	0x19
OptReg          equ     0x01
;////////////    ROM ALANI   /////////////
LcdByte         equ     0x0C
T0              equ     0x0D            ; Genel Amacli Registerlar
T1              equ     0x0E
Tmp0            equ     0x0F
ColonSay        equ     0x10
TxFq1           equ     0x11            ; Binary frq storage for Tx
TxFq2           equ     0x12
count           equ     0x13
H_byte          equ     0x14
L_byte          equ     0x15
NVadres		equ	0x16
;;;;;;;;;   3 bos alannnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
Debounce        equ     0x1A
RowSay          equ     0x1B
Row             equ     0x1C
Colon           equ     0x1D
R0              equ     0x1E
R1              equ     0x1F
R2              equ     0x20
ACCaLO          equ     0x21
ACCaHI          equ     0x22
ACCbLO          equ     0x23
ACCbHI          equ     0x24
ACCcLO          equ     0x25
ACCcHI          equ     0x26
ACCdLO          equ     0x27
ACCdHI          equ     0x28
NewKey          equ     0x29
Tus             equ     0x2A
Flag            equ     0x2B
S_DATA          equ     0x2C
Reg_N		equ	0x2D
Reg_A		equ	0x2E
;"""""""""""""""""""""""""""""""""""""""""""""""""""
         ORG 0x00
InitPorts
        clrwdt
	clrf	Flag
	bsf	RTxPl
        clrf    NewKey
        movlw   4
        movwf   Debounce
        bsf     STATUS,RP0
        movlw   0x10
        movwf   PORT_A
        clrf    PORT_B
        bcf     OptReg,7        ; Enable Pull-up PortB
        bcf     STATUS,RP0
        call    INITLCD
        movlw   h'80'
        CALL    CMDLCD
        movlw   'V'
        call    CHARLCD
        movlw   'H'
        call    CHARLCD
        movlw   'F'
        call    CHARLCD
        movlw   ' '
        call    CHARLCD
        movlw   'S'
        call    CHARLCD
        movlw   'Y'
        call    CHARLCD
        movlw   'N'
        call    CHARLCD
        movlw   'T'
        call    CHARLCD

        movlw   h'8a'
        CALL    CMDLCD
        movlw   'T'
        call    CHARLCD
        movlw   'A'
        call    CHARLCD
        movlw   '7'
        call    CHARLCD
        movlw   'B'
        call    CHARLCD
        movlw   'C'
        call    CHARLCD
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GetTFrq 
        movlw   TxInitHI                    ;45600
        movwf   TxFq1
        movlw   TxInitLO
        movwf   TxFq2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        call    CHAR8
        call    ClcPll
        goto    Tx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TTx   
        cbs     RxTx,FDispR
        cbc     RxTx,FDispT
        return
Tx      call    TTx
        Call    MyKbd
        movf    NewKey,w
        xorlw   2
        cz      FrqInc
        movf    NewKey,w
        xorlw   5
        cz      FrqDec
        movf    NewKey,w
        xorlw   8
        cz      SimDbl
        movf    NewKey,w
        xorlw   9
        cz      ClcPll
        bcf     KeyFl
        clrf    NewKey
        goto    Tx
;........................................
SimDbl
        movlw   10
        xorwf   Flag,f
        movlw   H'CE'
        call    CMDLCD
        btfsc   Dublx
        goto    DoDblx
        movlw   ' '
        call    CHARLCD
        goto    Dbwt
DoDblx
        movlw   '-'
        call    CHARLCD
Dbwt
        call    MyKbd
        btfsc   KeyFl
        goto    Dbwt
        bcf     KeyFl
        return
;.........................................
FDispR
        movf    TxFq1,w
        movwf   H_byte
        movf    TxFq2,w
        movwf   L_byte
        call    B2_BCD
        movlw   2
        movwf   ColonSay
        call    RxMsg
        movlw   R0              ; First display MSB
        movwf   FSR
        movf    INDF,W
        andlw   0f
        call    NUMLCD
        incf    FSR
FdispR2 swapf   INDF,W
        andlw   0f
        call    NUMLCD
        movf    INDF,W
        andlw   0f
        call    NUMLCD
        incf    FSR
        decfsz  ColonSay
        goto    FdispR2
        call    MhzMsg
        return
;txtxtxtxtxtxtxtxt     check PTT if press down set new PLL frequency.
RxTxCnt
        btfsc   RxTx		
        return			; Demekki PTT basili degil
	bsf	RTxPl
        call    ClcPll		
TxBek           
        jbc     RxTx,TxBek	; Transmit durumundayiz PTT birakilsin!
        call    FDispR
	bcf	RTxPl
        goto	ClcPll
;//////////////////////////////
FDispT
        btfsc   Dublx
        goto    DoSmx

        movf    TxFq1,w
        movwf   H_byte
        movf    TxFq2,w
        movwf   L_byte
        goto    CntDsp
DoSmx
        Call    Grx                     ; -600khz Shift
CntDsp
        call    B2_BCD
        movlw   2
        movwf   ColonSay
        call    TxMsg
        movlw   R0              ;First Display MSB
        movwf   FSR
        movf    INDF,W
        andlw   0f
        call    NUMLCD
        incf    FSR
FdispT2 swapf   INDF,W
        andlw   0f
        call    NUMLCD
        movf    INDF,W
        andlw   0f
        call    NUMLCD
        incf    FSR
        decfsz  ColonSay
        goto    FdispT2
        call    MhzMsg
        goto    RxTxCnt
;///////////////////////////        
MhzMsg  movlw   'M'
        call    CHARLCD
        movlw   'h'
        call    CHARLCD
        movlw   'z'
        call    CHARLCD
        return
;///////////////////////////////////////
TxMsg   Call    CHAR8
        movlw   'T'
        call    CHARLCD
        movlw   'x'
        call    CHARLCD
        movlw   '='
        call    CHARLCD
        movlw   '1'
        call    CHARLCD
        return
;//////////////////////////////////////
RxMsg   Call    CHAR8
        movlw   'R'
        call    CHARLCD
        movlw   'x'
        call    CHARLCD
        movlw   '='
        call    CHARLCD
        movlw   '1'
        call    CHARLCD
        return
;///////////////////////////////////////
FrqInc  
        movf    TxFq1,w
        movwf   ACCbHI
        movf    TxFq2,w
        movwf   ACCbLO

        movlw   ChnlFq		;25khz increment
        movwf   ACCaLO
        clrf	ACCaHI
        call    D_add

        movf    ACCbHI,w
        movwf   TxFq1
        movf    ACCbLO,w
        movwf   TxFq2
        Call	TTx
	call	ClcPll
RlsIncx
        call    MyKbd
        btfsc   KeyFl
        goto    RlsIncx
        bcf     KeyFl
        return
;////////////////////////////////////////
FrqDec
        movf    TxFq2,w
        movwf   ACCbLO
        movf    TxFq1,w
        movwf   ACCbHI

        movlw   ChnlFq		;25khz DECREMENT
        movwf   ACCaLO
        clrf	ACCaHI
        call    D_sub

        movf    ACCbHI,w
        movwf   TxFq1
        movf    ACCbLO,w
        movwf   TxFq2
        Call	TTx
	Call	ClcPll
RlsDecx
        call    MyKbd
        btfsc   KeyFl
        goto    RlsDecx
        bcf     KeyFl
        return
;/////////////////// Almada 21400 khz Asagisina gel //////////////////////
GPllRx
        movf    TxFq1,w
        movwf   ACCbHI
        movf    TxFq2,w
        movwf   ACCbLO

        movlw   IFLO		;21.400 Mhz Rx frekansi
        movwf   ACCaLO
        movlw   IFHI		
        movwf   ACCaHI
        call    D_sub
        return
;/////////////////////////////////////////
Grx
        movf    TxFq1,w
        movwf   ACCbHI
        movf    TxFq2,w
        movwf   ACCbLO

        movlw   SFTLO            ; -600d=>0258h shift ver
        movwf   ACCaLO
        movlw   SFTHI
        movwf   ACCaHI
        call    D_sub

        movf    ACCbHI,w
        movwf   H_byte
        movf    ACCbLO,w
        movwf   L_byte
        return
;**************************************************
; The LCD operates in nibble mode
;   PORT A is the data bus
;   PORT B contains the control lines
INITLCD  CALL      DLY15     ;delay 15ms
         MOVLW     03        ;output function set
         MOVWF     PORT_A
         BSF       EnLcd      ;send first function set
         CALL      DLY5      ;delay 5ms
         BCF       EnLcd
         BSF       EnLcd      ;send second function set
         CALL      DLY5      ;delay 5ms
         BCF       EnLcd
         BSF       EnLcd      ;send third function set
         CALL      DLY5      ;delay 5ms
         BCF       EnLcd
         MOVLW     02
         MOVWF     PORT_A     ;set 4 bit mode
         CALL      SEND
         MOVLW     28        ;send 4bits, 2 line, 5X7 dots
         CALL      CMDLCD    ;send command to LCD
         MOVLW     0C        ;send DISPLAY ON
         CALL      CMDLCD
         MOVLW     06        ;send ENTRY MODE SET
         CALL      CMDLCD
         CALL      CLRDSP    ;clear the display
         RETurn
;*********************************************************************
;  Delay timer.  Delay = 771*MSD microseconds (.197 sec max)
;  entry CALL DELAY, W = MSD
;  CALL DLY200 implements a 200 us delay
DLY15    CALL      DLY5
         CALL      DLY5
DLY5     MOVLW     07
         GOTO      DELAY
DLY200   MOVLW     40        ;delay 200us
         MOVWF     T1
         MOVLW     01
         GOTO      DELAY2
DELAY    CLRF      T1
DELAY2   MOVWF     T0
DELAYL   DECFSZ    T1,f        ;decrement LSB until zero
         GOTO      DELAYL
         DECFSZ    T0,f        ;decrement MSB until zero
         GOTO      DELAYL
         RETurn                 ;exit
;*************************************************************************
;  Send one byte to LCD
;  CALL CMDLCD  sends command in W to LCD
;  CALL NUMLCD  sends BCD digit in low nibble in W as ASCII char
;  CALL CHARLCD sends ASCII character in W to LCD
;There is a 200 us delay built into the end of the routine.
;
CHAR8    MOVLW     0xc0      ;SET TO SECOND 8 CHARS
CMDLCD   MOVWF     LcdByte        ;save byte
         bcf       EnLcd
         bcf       RsLcd     ;SET /RW, /ENB, /RS
         GOTO      SENDLCD
NUMLCD   ANDLW     0F        ;mask LS nibble
         IORLW     30        ;make ASCII number
CHARLCD  MOVWF     LcdByte        ;save byte
         bcf       EnLcd
         bsf       RsLcd
SENDLCD  SWAPF     LcdByte,f  ;send high nibble first
         MOVF      LcdByte,W
         MOVWF     PORT_A
         BSF       EnLcd      ;toggle ENB on
         BCF       EnLcd      ;toggle ENB off
         SWAPF     LcdByte,f  ;swap nibbles
         MOVF      LcdByte,W
         MOVWF     PORT_A     ;send low nibble
SEND     BSF       EnLcd      ;toggle ENB on
         BCF       EnLcd      ;toggle ENB off
         CALL      DLY200     ;delay 200us
         RETurn               ;exit
;************************************************************************
CLRDSP   MOVLW     1
CLR6     CALL      CMDLCD    ;clear display
         CALL      DLY5      ;delay 5ms
         MOVLW     28        ;set 4 bit 2 line
         CALL      CMDLCD
         REturn
;**********************************
DISPSP   MOVLW     ' '
         CALL      CHARLCD
         RETURN
;*******************************************************************;
B2_BCD  bcf     STATUS,C                ; clear the carry bit
        movlw   .16
        movwf   count
        clrf    R0
        clrf    R1
        clrf    R2
loop16  rlf     L_byte
        rlf     H_byte
        rlf     R2
        rlf     R1
        rlf     R0
;
        decfsz  count
        goto    adjDEC
        RETLW   0
;
adjDEC  movlw   R2
        movwf   FSR
        call    adjBCD
;
        movlw   R1
        movwf   FSR
        call    adjBCD
;
        movlw   R0
        movwf   FSR
        call    adjBCD
;
        goto    loop16
;
adjBCD  movlw   3
        addwf   0,W
        movwf   Tmp0
        btfsc   Tmp0,3          ; test if result > 7
        movwf   0
        movlw   30
        addwf   0,W
        movwf   Tmp0
        btfsc   Tmp0,7          ; test if result > 7
        movwf   0               ; save as MSD
        RETLW   0
;*******************************************************************
;                 Double Precision Addition & Subtraction
;*******************************************************************;
;   Addition :  ACCb(16 bits) + ACCa(16 bits) -> ACCb(16 bits)
;      (a) Load the 1st operand in location ACCaLO & ACCaHI ( 16 bits )
;      (b) Load the 2nd operand in location ACCbLO & ACCbHI ( 16 bits )
;      (c) CALL D_add
;      (d) The result is in location ACCbLO & ACCbHI ( 16 bits )
;
;   Performance :
;               Program Memory  :       07
;               Clock Cycles    :       08
;*******************************************************************;
;   Subtraction : ACCb(16 bits) - ACCa(16 bits) -> ACCb(16 bits)
;      (a) Load the 1st operand in location ACCaLO & ACCaHI ( 16 bits )
;      (b) Load the 2nd operand in location ACCbLO & ACCbHI ( 16 bits )
;      (c) CALL D_sub
;      (d) The result is in location ACCbLO & ACCbHI ( 16 bits )
;
;   Performance :
;               Program Memory  :       14
;               Clock Cycles    :       17
;*******************************************************************;
;
D_sub   call    neg_A           ; At first negate ACCa; Then add
;
;*******************************************************************
;       Double Precision  Addition ( ACCb + ACCa -> ACCb )
;
D_add   movf    ACCaLO,w
        addwf   ACCbLO          ;add lsb
        btfsc   STATUS,C    ;add in carry
        incf    ACCbHI
        movf    ACCaHI,w
        addwf   ACCbHI            ;add msb
        return
neg_A   comf    ACCaLO          ; negate ACCa ( -ACCa -> ACCa )
        incf    ACCaLO
        btfsc   STATUS,Z
        decf    ACCaHI
        comf    ACCaHI
        return
;mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
;                    Double Precision Multiplication
;               ( Optimized for Code Size : Looped Code )
;*******************************************************************;
;   Multiplication : ACCb(16 bits) * ACCa(16 bits) -> ACCb,ACCc ( 32 bits )
;      (a) Load the 1st operand in location ACCaLO & ACCaHI ( 16 bits )
;      (b) Load the 2nd operand in location ACCbLO & ACCbHI ( 16 bits )
;      (c) CALL D_mpy
;      (d) The 32 bit result is in location ( ACCbHI,ACCbLO,ACCcHI,ACCcLO )
;*******************************************************************
;               Double Precision Multiply ( 16x16 -> 32 )
;         ( ACCb*ACCa -> ACCb,ACCc ) : 32 bit output with high word
;  in ACCb ( ACCbHI,ACCbLO ) and low word in ACCc ( ACCcHI,ACCcLO ).
;
D_mpyS                           ;results in ACCb(16 msb's) and ACCc(16 lsb's)
;
	call    setupm
mloop   rrf     ACCdHI          ;rotate d right
	rrf     ACCdLO
	btfsc   STATUS,C	;need to add?
	call    D_add
	rrf     ACCbHI
	rrf     ACCbLO
	rrf     ACCcHI
	rrf     ACCcLO
	decfsz  Tmp0            ;loop until all bits checked
	goto    mloop
	return
setupm  movlw   .16             ; for 16 shifts
	movwf   Tmp0
	movf    ACCbHI,w          ;move ACCb to ACCd
	movwf   ACCdHI
	movf    ACCbLO,w
	movwf   ACCdLO
	clrf    ACCbHI
	clrf    ACCbLO
	return
;***************************************************
MyKbd   btfss   KeyDF
        goto    K0
        decfsz  Debounce,f
        return
        bcf     KeyDF
        return
K0      
        call    SavePorts
        clrf    Tus
        movlw   5
        movwf   RowSay
        movlw   3
        movwf   ColonSay
        movlw   0xfe		; 1111 1110
        movwf   Row
K1 
        decf    RowSay
        jz      NoTus
        movf    Row,W
        movwf   PORT_A
        call    DLY200

        movf    PORT_B,W
        andwf   0f
        xorlw   0f
        movwf   Colon
        jnz     col1
        bsf     STATUS,C
        rlf     Row
        movlw   3
        addwf   Tus
        goto    K1
NoTus   bcf     KeyFl
        goto    TusCik
col1    rrf     Colon
        btfsc   STATUS,C
        goto    basildi
        incf    Tus
        decf    ColonSay
        btfsc   STATUS,Z
        goto    NoTus
        goto    col1
basildi 
        movf    Tus,W
        movwf   NewKey
        bsf     KeyFl
        bsf     KeyDF
TusCik
        call    RestorePorts
TusCik2 
        movlw   4
        movwf   Debounce
        return
SavePorts
        movlw   0f
        movwf   PORT_B
        movlw   0x10
        bsf     STATUS,RP0
        movwf   PORT_A
        movlw   0F
        movwf   PORT_B
        bcf     OptReg,7
        bcf     STATUS,RP0
        return
RestorePorts
        movlw   0x10
        bsf     STATUS,RP0
        movwf   PORT_A
        movlw   0
        movwf   PORT_B
        bcf     STATUS,RP0
        return
;*******************************************************************
;                       Double Precision Division
;               ( Optimized for Code Size : Looped Code )
;*******************************************************************;
;   Division : ACCb(16 bits) / ACCa(16 bits) -> ACCb(16 bits) with
;                                               Remainder in ACCc (16 bits)
;      (a) Load the Denominator in location ACCaHI & ACCaLO ( 16 bits )
;      (b) Load the Numerator in location ACCbHI & ACCbLO ( 16 bits )
;      (c) CALL D_div
;      (d) The 16 bit result is in location ACCbHI & ACCbLO
;      (e) The 16 bit Remainder is in locations ACCcHI & ACCcLO
;
;   Performance :
;               Program Memory  :       037
;               Clock Cycles    :       310
;*******************************************************************
;       Double Precision Divide ( 16/16 -> 16 )
;
;         ( ACCb/ACCa -> ACCb with remainder in ACCc ) : 16 bit output
; with Quotiont in ACCb (ACCbHI,ACCbLO) and Remainder in ACCc (ACCcHI,ACCcLO).
;
;   NOTE  :  Before calling this routine, the user should make sure that
;            the Numerator(ACCb) is greater than Denominator(ACCa). If
;            the case is not true, the user should scale either Numerator
;            or Denominator or both such that Numerator is greater than
;            the Denominator.
D_divS
        call    setup
        clrf    ACCcHI
        clrf    ACCcLO
dloop   bcf     STATUS,C
        rlf     ACCdLO
        rlf     ACCdHI
        rlf     ACCcLO
        rlf     ACCcHI
        movf    ACCaHI,w
        subwf   ACCcHI,w        ;check if a>c
        btfss   STATUS,Z
        goto    nochk
        movf    ACCaLO,w
        subwf   ACCcLO,w        ;if msb equal then check lsb
nochk   btfss   STATUS,C    	;carry set if c>a
        goto    nogo
        movf    ACCaLO,w        ;c-a into c
        subwf   ACCcLO
        btfss   STATUS,C
        decf    ACCcHI
        movf    ACCaHI,w
        subwf   ACCcHI
        bsf     STATUS,C    	;shift a 1 into b (result)
nogo    rlf     ACCbLO
        rlf     ACCbHI
        decfsz  Tmp0            ;loop untill all bits checked
        goto    dloop
        retlw   0
;*******************************************************************
setup   movlw   .16		; for 16 shifts
        movwf   Tmp0
        movf    ACCbHI,w	;move ACCb to ACCd
        movwf   ACCdHI
        movf    ACCbLO,w
        movwf   ACCdLO
        clrf    ACCbHI
        clrf    ACCbLO
        retlw   0
;*******************************************************************
Dneg_A	comf    ACCaLO          ; negate ACCa ( -ACCa -> ACCa )
        incf    ACCaLO
        btfsc   STATUS,Z
        decf    ACCaHI
        comf    ACCaHI
        retlw   0
;*******************************************************************
;		PLL frekansi hesaplanmasi ve yazilmasi. 22/12/97
ClcPll
	jbc	RTxPl,ClcRx
ClcTx	
       	movf    TxFq1,w
       	movwf   ACCbHI
       	movf	TxFq2,w           ; loads ACCb = Txfq
       	movwf   ACCbLO
	btfsc	Dublx
	call	Grx		; Dublex Moddayiz -600khz asagisi
	goto	CalcPll
ClcRx
	call	GPllRx		; Tx'ten 21.400 cikart alma freq olsun.
CalcPll 			; onceden ACCb ye Rx/Tx frekansi store edilir.
 	movlw   0
       	movwf   ACCaHI
       	movlw   .25		; loads ACCa = 25khz
       	movwf   ACCaLO
        call    D_divS          ; 
	movf	ACCbLO,w	; ACCb / ACCa => ACCb kalan ACCc de
	movwf	Reg_N		

 	movlw   0
       	movwf   ACCaHI
       	movlw   .40		; loads ACCa 40 ==> 40
       	movwf   ACCaLO
        call    D_divS          ; 
	movf	ACCbLO,w	; ACCb / ACCa => ACCb kalan ACCc de
	addlw	.100
	movwf	Reg_N		; 44,45 olmasi gerekir. buna 100 ilave ediyoruz
	movf	ACCcLO,w	; 
	movwf	Reg_A		; Kalan ACCc'de bunuda Reg_A'ya atiyoruz
	bcf	RTxPl
SendPll
	movf	Reg_N,w
        call    LOAD_DATA
        CALL    SERIAL_W
        movf	Reg_A,w		
        call    LOAD_DATA
        CALL    SERIAL_W
SPllcik
        call    MyKbd
        btfsc   KeyFl
        goto    SPllcik
        bcf     KeyFl
        return
;][][][][][][][][][][][][][][][][][][][][
LOAD_DATA
        MOVWF   S_DATA          ;move into S_DATA
        movlw   08
        movwf   count
        RETurn                  ;done, return with 0 in W reg.
SERIAL_W
        Nop
LOOP    
        RLF     S_DATA, F
        SKPC                    ;test if 1 or 0
        GOTO    ZEROx           ;its a zero
        Bsf     DtPll           ;its a one, set data bit
        GOTO    CLK_DATA        ;clock it
ZEROx
        Bcf     DtPll           ;zero, clear data bit
        GOTO    CLK_DATA        ;clock it, use ... delay
CLK_DATA
        bsf     EnPll
        bsf     CkPll           ;Clock SCLK, Active high
        bcf     CkPll
        DECFSZ  count, F        ;dec count and check if zero
        GOTO    LOOP            ;not done, goto loop
        bcf     EnPll
        RETurn            ;done, return with 0 in W reg.
;**************************************************************
        ;         17:59:10  5/18/1995          Huseyin AKGUL
        ; Data ve adresin EEPROM Data memory'ye yazma programi
SetDataMemory
        btfsc   Ramky            ; Ram'a yazma varsa iptal et
        goto    RamDon

        incf    NVadres
        movf    NVadres,w
        movwf   EEADRES

        movf    TxFq1,w
        movwf   EEDATA
        Call    RamWr

        incf    NVadres
        movf    NVadres,w
        movwf   EEADRES
        movf    TxFq2,w
        movwf   EEDATA
        Call    RamWr
RamDon  
        bcf     Ramky           ; Ram'a yazma bitti flag'i
        return
        ;
RamWr   bsf     Ramky
        bcf     INTCON,EEIE
        bsf     STATUS,RP0               ; select page 1
        bsf     EECON1,WREN
        movlw   0x55
        movwf   EECON2
        movlw   0xAA
        movwf   EECON2
        bsf     EECON1,WR
Bitmedi
        btfss   EECON1,EEIF
        goto    Bitmedi
        bcf     EECON1,WREN
        bcf     EECON1,EEIF              ; yazma bitti flaginin sifir olmali
        bcf     STATUS,RP0               ; select page 0
        return
ReadRam
        movf    NVadres,w
        movwf   EEADRES
        bsf     STATUS,RP0
        bsf     EECON1,RD
        bcf     STATUS,RP0
        movf    EEDATA,w
        return
	end
